/***********************************************************************

Author : Jose Adriano Baltieri
         jabaltie@iep-cen.unimep.br
         21/09/99 09:09:35

         There's a 2.5 version (DOS) available too.

Make yourself comfortable to improve it. Just let me know if you did
something interesting, OK ?

Variables follow the pattern : STname where S is the scope : Global
                                                             Local
                                            T is the type  : Integer
                                                             String

***********************************************************************/

integer ginfiles

string proc dateswp(string lsdate)

string lsodate[8]

lsodate=Format(Trim(SubStr(lsdate,7,2)):2:"0") + "/" + Format(Trim(SubStr(lsdate,4,2)):2:"0") + "/" + Format(Trim(SubStr(lsdate,1,2)):2:"0")

return(lsodate)

end

string proc attrtostr(integer liattr)

string lsoutput[200]=""

if  _NORMAL_ & liattr
    lsoutput=lsoutput + "n"
endif

if  _READONLY_ & liattr
    lsoutput=lsoutput + "r"
endif

if  _HIDDEN_ & liattr
    lsoutput=lsoutput + "h"
endif

if  _SYSTEM_ & liattr
    lsoutput=lsoutput + "s"
endif

if  _VOLUME_ & liattr
    lsoutput=lsoutput + "v"
endif

if  _DIRECTORY_ & liattr
    lsoutput=lsoutput + "d"
endif

if  _ARCHIVE_ & liattr
    lsoutput=lsoutput + "a"
endif

return(Trim(lsoutput))

end

proc dolistfiles(string lspath,string lsattr,string lsprefix,integer lirecurse,integer liprintdirs)

integer lip,lih

lih=FindFirstFile(SplitPath(lspath,_DRIVE_|_PATH_) + "*.*",-1)

if  lih <> -1
    repeat
        if  (FFAttribute() & _DIRECTORY_)
            if  (FFName() in ".","..")
                goto DISCARD
            endif
            if  liprintdirs <> 1
                goto DISCARD
            endif
        else
            if  not MatchFilename(FFName(),SplitPath(lspath,_NAME_|_EXT_))
                goto DISCARD
            endif
        endif
        for lip=1 to Length(lsattr)
            case lsattr[lip:1]
                when "D"
                  InsertText(Format(dateswp(FFDateStr()):-09),_INSERT_)
                when "T"
                  InsertText(Format(FFTimeStr():-09),_INSERT_)
                when "S"
                  InsertText(Format(FFSize():10) + " ",_INSERT_)
                when "A"
                  InsertText(Format(attrtostr(FFAttribute()):-08),_INSERT_)
            endcase
        endfor
        InsertText(lsprefix + iif(Length(lsprefix) > 0 and lsprefix[Length(lsprefix):1] <> " "," ","") + Upper(SplitPath(lspath,_DRIVE_|_PATH_)) + FFName(),_INSERT_)
        CReturn()
        if  CurrCol() <> 1
            GotoColumn(1)
        endif
        ginfiles=ginfiles + 1
      DISCARD:
      if  lirecurse == 1
          if  (FFAttribute() & _DIRECTORY_)
          and (not (FFName() in ".",".."))
              dolistfiles(SplitPath(lspath,_DRIVE_|_PATH_) + Trim(FFName()) + "\" + SplitPath(lspath,_NAME_|_EXT_),lsattr,lsprefix,lirecurse,liprintdirs)
          endif
      endif
    until not FindNextFile(lih,_DIRECTORY_ + _NORMAL_)
endif

end


proc Main()

string lspath[255]
string lsattr[4]
string lsprefix[255]
string lssuffix[255]
integer lirecurse,liprintdirs
integer lilongest
integer lipathh,lirecurseh,liprintdirsh,lidtsah,liprefixh,lisuffixh

integer liOK,lii,lisindent

ginfiles=0

repeat
  lipathh=GetFreeHistory("DIRLIST:path")
  lspath=GetHistoryStr(lipathh,1)
  if  lspath == ""
      lspath = CurrDir() + "*.*"
  endif
  liOK=FALSE
  while not liOK
    if  not Ask("Path for directory listing (usually ended by an '*.*') :",lspath,lipathh)
        return()
    endif
    if  lspath[1:1] == "\"
        lspath=SubStr(CurrDir(),1,2) + lspath
    else
        if  Length(lspath) > 1
        and (not (lspath[2:1] == ":"))
            lspath=CurrDir() + lspath
        endif
    endif
    lirecurseh=GetFreeHistory("DIRLIST:recurse")
    lirecurse=Val(GetHistoryStr(lirecurseh,1))
    if  lirecurse == 2
        PushKey(<CursorDown>)
    endif
    lirecurse=YesNo("Do you want to recurse into subdirectories ?")
    if  lirecurse == 0
        return()
    endif
    if  (lirecurse == 2)
    and (not FileExists(lspath))
        Warn("No files under this path : " + lspath)
    else
        liOK=TRUE
    endif
    AddHistoryStr(Str(lirecurse,1),lirecurseh)
  endwhile
  AddHistoryStr(lspath,lipathh)

  liprintdirsh=GetFreeHistory("DIRLIST:printdir")
  liprintdirs=Val(GetHistoryStr(liprintdirsh,1))
  if  liprintdirs == 2
      PushKey(<CursorDown>)
  endif
  liprintdirs=YesNo("Should directory entries be included ?")
  if  liprintdirs == 0
      return()
  endif
  AddHistoryStr(Str(liprintdirs,1),liprintdirsh)

  lidtsah=GetFreeHistory("DIRLIST:dtsa")
  lsattr=GetHistoryStr(lidtsah,1)
  repeat
    if  not Ask("Prefix each line with Date Time Size and/or Attributes (and which order) : ",lsattr,lidtsah)
        return()
    endif
    lsattr=Upper(lsattr)
    liOK=TRUE
    for lii=1 to Length(lsattr)
        if  not (lsAttr[lii] in "D", "T", "S", "A")
            liOK=FALSE
            break
        endif
    endfor
  until liOK
  AddHistoryStr(lsattr,lidtsah)

  liprefixh=GetFreeHistory("DIRLIST:prefix")
  lsprefix=GetHistoryStr(liprefixh,1)
  if  not Ask("Additional prefix text for each line : ",lsprefix,liprefixh)
      return()
  endif
  AddHistoryStr(lsprefix,liprefixh)

  lisuffixh=GetFreeHistory("DIRLIST:suffix")
  lssuffix=GetHistoryStr(lisuffixh,1)
  if  not Ask("Additional suffix text for each line : ",lssuffix,lisuffixh)
      return()
  endif
  AddHistoryStr(lssuffix,lisuffixh)

  NewFile()

  lisindent=Query(AutoIndent)

  Set(AutoIndent,FALSE)

  dolistfiles(lspath,lsattr,lsprefix,lirecurse,liprintdirs)

  if  ginfiles == 0
      Warn("No files under this path : " + lspath)
  endif

until ginfiles > 0

ExecMacro("longstln")

lilongest=CurrLineLen() + 2

BegFile()
repeat
    GotoColumn(lilongest)
    InsertText(lssuffix,_INSERT_)
    Down()
until CurrLine() == NumLines()

BegFile()

Set(AutoIndent,lisindent)

end
